<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleHangingMuscle.cpp</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleHangingMuscle_8cpp-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleHangingMuscle.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<p>This example optimizes the motion of a point mass actuated by a single muscle and shows you how to use the AnalyzeTool and a metabolic probe with a MocoSolution.</p>
<div class="fragment"><div class="line"><span class="comment">/* -------------------------------------------------------------------------- *</span></div>
<div class="line"><span class="comment"> * OpenSim Moco: exampleHangingMuscle.cpp                                     *</span></div>
<div class="line"><span class="comment"> * -------------------------------------------------------------------------- *</span></div>
<div class="line"><span class="comment"> * Copyright (c) 2020 Stanford University and the Authors                     *</span></div>
<div class="line"><span class="comment"> *                                                                            *</span></div>
<div class="line"><span class="comment"> * Author(s): Christopher Dembia                                              *</span></div>
<div class="line"><span class="comment"> *                                                                            *</span></div>
<div class="line"><span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may    *</span></div>
<div class="line"><span class="comment"> * not use this file except in compliance with the License. You may obtain a  *</span></div>
<div class="line"><span class="comment"> * copy of the License at http://www.apache.org/licenses/LICENSE-2.0          *</span></div>
<div class="line"><span class="comment"> *                                                                            *</span></div>
<div class="line"><span class="comment"> * Unless required by applicable law or agreed to in writing, software        *</span></div>
<div class="line"><span class="comment"> * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,          *</span></div>
<div class="line"><span class="comment"> * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   *</span></div>
<div class="line"><span class="comment"> * See the License for the specific language governing permissions and        *</span></div>
<div class="line"><span class="comment"> * limitations under the License.                                             *</span></div>
<div class="line"><span class="comment"> * -------------------------------------------------------------------------- */</span></div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line"><span class="preprocessor">#include &lt;OpenSim/Analyses/MuscleAnalysis.h&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;OpenSim/Analyses/ProbeReporter.h&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;OpenSim/Common/STOFileAdapter.h&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;OpenSim/Moco/osimMoco.h&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;OpenSim/Simulation/SimbodyEngine/PinJoint.h&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;OpenSim/Tools/AnalyzeTool.h&gt;</span></div>
<div class="line"> </div>
<div class="line"><span class="keyword">using namespace </span><a class="code" href="namespaceOpenSim.html">OpenSim</a>;</div>
<div class="line"> </div>
<div class="line">Model createHangingMuscleModel(<span class="keywordtype">bool</span> ignoreActivationDynamics,</div>
<div class="line">        <span class="keywordtype">bool</span> ignoreTendonCompliance) {</div>
<div class="line">    Model model;</div>
<div class="line">    model.setName(<span class="stringliteral">&quot;hanging_muscle&quot;</span>);</div>
<div class="line">    model.set_gravity(SimTK::Vec3(9.81, 0, 0));</div>
<div class="line">    <span class="keyword">auto</span>* body = <span class="keyword">new</span> Body(<span class="stringliteral">&quot;body&quot;</span>, 0.5, SimTK::Vec3(0), SimTK::Inertia(0));</div>
<div class="line">    model.addComponent(body);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Allows translation along x.</span></div>
<div class="line">    <span class="keyword">auto</span>* joint = <span class="keyword">new</span> SliderJoint(<span class="stringliteral">&quot;joint&quot;</span>, model.getGround(), *body);</div>
<div class="line">    <span class="keyword">auto</span>&amp; coord = joint-&gt;updCoordinate(<a name="a0"></a><a class="code" href="classOpenSim_1_1SliderJoint.html#a1c93d708a12564b46fcde77bb4be66eaadf25457a4acbb8220b36cbd34903fc06">SliderJoint::Coord::TranslationX</a>);</div>
<div class="line">    coord.setName(<span class="stringliteral">&quot;height&quot;</span>);</div>
<div class="line">    model.addComponent(joint);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// The point mass is supported by a muscle. The DeGrooteFregly2016Muscle</span></div>
<div class="line">    <span class="comment">// is the only muscle model in OpenSim that has been tested with Moco.</span></div>
<div class="line">    <span class="keyword">auto</span>* actu = <span class="keyword">new</span> DeGrooteFregly2016Muscle();</div>
<div class="line">    actu-&gt;setName(<span class="stringliteral">&quot;muscle&quot;</span>);</div>
<div class="line">    actu-&gt;set_max_isometric_force(30.0);</div>
<div class="line">    actu-&gt;set_optimal_fiber_length(0.10);</div>
<div class="line">    actu-&gt;set_tendon_slack_length(0.05);</div>
<div class="line">    actu-&gt;set_tendon_strain_at_one_norm_force(0.10);</div>
<div class="line">    actu-&gt;set_ignore_activation_dynamics(ignoreActivationDynamics);</div>
<div class="line">    actu-&gt;set_ignore_tendon_compliance(ignoreTendonCompliance);</div>
<div class="line">    actu-&gt;set_fiber_damping(0.01);</div>
<div class="line">    <span class="comment">// The DeGrooteFregly2016Muscle is the only muscle model in OpenSim that</span></div>
<div class="line">    <span class="comment">// can express its tendon compliance dynamics using an implicit</span></div>
<div class="line">    <span class="comment">// differential equation.</span></div>
<div class="line">    actu-&gt;set_tendon_compliance_dynamics_mode(<span class="stringliteral">&quot;implicit&quot;</span>);</div>
<div class="line">    actu-&gt;set_max_contraction_velocity(10);</div>
<div class="line">    actu-&gt;set_pennation_angle_at_optimal(0.10);</div>
<div class="line">    actu-&gt;addNewPathPoint(<span class="stringliteral">&quot;origin&quot;</span>, model.updGround(), SimTK::Vec3(0));</div>
<div class="line">    actu-&gt;addNewPathPoint(<span class="stringliteral">&quot;insertion&quot;</span>, *body, SimTK::Vec3(0));</div>
<div class="line">    model.addForce(actu);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Add metabolics probes: one for the total metabolic rate,</span></div>
<div class="line">    <span class="comment">// and one for each term in the metabolics model.</span></div>
<div class="line">    {</div>
<div class="line">        <span class="keyword">auto</span>* probe = <span class="keyword">new</span> Umberger2010MuscleMetabolicsProbe();</div>
<div class="line">        probe-&gt;setName(<span class="stringliteral">&quot;metabolics&quot;</span>);</div>
<div class="line">        probe-&gt;addMuscle(<span class="stringliteral">&quot;muscle&quot;</span>, 0.5);</div>
<div class="line">        model.addProbe(probe);</div>
<div class="line">    }</div>
<div class="line">    {</div>
<div class="line">        <span class="keyword">auto</span>* probe = <span class="keyword">new</span> Umberger2010MuscleMetabolicsProbe();</div>
<div class="line">        probe-&gt;setName(<span class="stringliteral">&quot;activation_maintenance_rate&quot;</span>);</div>
<div class="line">        probe-&gt;set_activation_maintenance_rate_on(<span class="keyword">true</span>);</div>
<div class="line">        probe-&gt;set_shortening_rate_on(<span class="keyword">false</span>);</div>
<div class="line">        probe-&gt;set_basal_rate_on(<span class="keyword">false</span>);</div>
<div class="line">        probe-&gt;set_mechanical_work_rate_on(<span class="keyword">false</span>);</div>
<div class="line">        probe-&gt;addMuscle(<span class="stringliteral">&quot;muscle&quot;</span>, 0.5);</div>
<div class="line">        model.addProbe(probe);</div>
<div class="line">    }</div>
<div class="line">    {</div>
<div class="line">        <span class="keyword">auto</span>* probe = <span class="keyword">new</span> Umberger2010MuscleMetabolicsProbe();</div>
<div class="line">        probe-&gt;setName(<span class="stringliteral">&quot;shortening_rate&quot;</span>);</div>
<div class="line">        probe-&gt;set_activation_maintenance_rate_on(<span class="keyword">false</span>);</div>
<div class="line">        probe-&gt;set_shortening_rate_on(<span class="keyword">true</span>);</div>
<div class="line">        probe-&gt;set_basal_rate_on(<span class="keyword">false</span>);</div>
<div class="line">        probe-&gt;set_mechanical_work_rate_on(<span class="keyword">false</span>);</div>
<div class="line">        probe-&gt;addMuscle(<span class="stringliteral">&quot;muscle&quot;</span>, 0.5);</div>
<div class="line">        model.addProbe(probe);</div>
<div class="line">    }</div>
<div class="line">    {</div>
<div class="line">        <span class="keyword">auto</span>* probe = <span class="keyword">new</span> Umberger2010MuscleMetabolicsProbe();</div>
<div class="line">        probe-&gt;setName(<span class="stringliteral">&quot;basal_rate&quot;</span>);</div>
<div class="line">        probe-&gt;set_activation_maintenance_rate_on(<span class="keyword">false</span>);</div>
<div class="line">        probe-&gt;set_shortening_rate_on(<span class="keyword">false</span>);</div>
<div class="line">        probe-&gt;set_basal_rate_on(<span class="keyword">true</span>);</div>
<div class="line">        probe-&gt;set_mechanical_work_rate_on(<span class="keyword">false</span>);</div>
<div class="line">        probe-&gt;addMuscle(<span class="stringliteral">&quot;muscle&quot;</span>, 0.5);</div>
<div class="line">        model.addProbe(probe);</div>
<div class="line">    }</div>
<div class="line">    {</div>
<div class="line">        <span class="keyword">auto</span>* probe = <span class="keyword">new</span> Umberger2010MuscleMetabolicsProbe();</div>
<div class="line">        probe-&gt;setName(<span class="stringliteral">&quot;mechanical_work_rate&quot;</span>);</div>
<div class="line">        probe-&gt;set_activation_maintenance_rate_on(<span class="keyword">false</span>);</div>
<div class="line">        probe-&gt;set_shortening_rate_on(<span class="keyword">false</span>);</div>
<div class="line">        probe-&gt;set_basal_rate_on(<span class="keyword">false</span>);</div>
<div class="line">        probe-&gt;set_mechanical_work_rate_on(<span class="keyword">true</span>);</div>
<div class="line">        probe-&gt;addMuscle(<span class="stringliteral">&quot;muscle&quot;</span>, 0.5);</div>
<div class="line">        model.addProbe(probe);</div>
<div class="line">    }</div>
<div class="line"> </div>
<div class="line">    body-&gt;attachGeometry(<span class="keyword">new</span> Sphere(0.05));</div>
<div class="line"> </div>
<div class="line">    model.finalizeConnections();</div>
<div class="line"> </div>
<div class="line">    <span class="keywordflow">return</span> model;</div>
<div class="line">}</div>
<div class="line"> </div>
<div class="line"><span class="keywordtype">int</span> main() {</div>
<div class="line"> </div>
<div class="line">    <span class="keyword">const</span> <span class="keywordtype">bool</span> ignoreActivationDynamics = <span class="keyword">false</span>;</div>
<div class="line">    <span class="keyword">const</span> <span class="keywordtype">bool</span> ignoreTendonCompliance = <span class="keyword">false</span>;</div>
<div class="line">    Model model = createHangingMuscleModel(ignoreActivationDynamics,</div>
<div class="line">            ignoreTendonCompliance);</div>
<div class="line">    model.print(<span class="stringliteral">&quot;hanging_muscle.osim&quot;</span>);</div>
<div class="line"> </div>
<div class="line">    MocoStudy study;</div>
<div class="line">    MocoProblem&amp; problem = study.updProblem();</div>
<div class="line">    problem.setModelAsCopy(model);</div>
<div class="line">    problem.setTimeBounds(0, {0.05, 1.0});</div>
<div class="line">    problem.setStateInfo(<span class="stringliteral">&quot;/joint/height/value&quot;</span>, {0.14, 0.16}, 0.15, 0.14);</div>
<div class="line">    problem.setStateInfo(<span class="stringliteral">&quot;/joint/height/speed&quot;</span>, {-1, 1}, 0, 0);</div>
<div class="line">    problem.setControlInfo(<span class="stringliteral">&quot;/forceset/muscle&quot;</span>, {0.01, 1});</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Initial state constraints/costs.</span></div>
<div class="line">    <span class="keywordflow">if</span> (!ignoreActivationDynamics) {</div>
<div class="line">        <span class="keyword">auto</span>* initial_activation = problem.addGoal&lt;MocoInitialActivationGoal&gt;();</div>
<div class="line">        initial_activation-&gt;setName(<span class="stringliteral">&quot;initial_activation&quot;</span>);</div>
<div class="line">    }</div>
<div class="line">    <span class="keywordflow">if</span> (!ignoreTendonCompliance) {</div>
<div class="line">        <span class="keyword">auto</span>* initial_equilibrium =</div>
<div class="line">                problem.addGoal&lt;MocoInitialVelocityEquilibriumDGFGoal&gt;();</div>
<div class="line">        initial_equilibrium-&gt;setName(<span class="stringliteral">&quot;initial_velocity_equilibrium&quot;</span>);</div>
<div class="line">        <span class="comment">// The problem converges in fewer iterations when this goal is in cost</span></div>
<div class="line">        <span class="comment">// mode.</span></div>
<div class="line">        initial_equilibrium-&gt;setMode(<span class="stringliteral">&quot;cost&quot;</span>);</div>
<div class="line">        initial_equilibrium-&gt;setWeight(0.001);</div>
<div class="line">    }</div>
<div class="line"> </div>
<div class="line">    problem.addGoal&lt;MocoFinalTimeGoal&gt;();</div>
<div class="line"> </div>
<div class="line">    <span class="keyword">auto</span>&amp; solver = study.initCasADiSolver();</div>
<div class="line">    solver.set_num_mesh_intervals(50);</div>
<div class="line">    solver.set_multibody_dynamics_mode(<span class="stringliteral">&quot;implicit&quot;</span>);</div>
<div class="line">    solver.set_optim_convergence_tolerance(1e-4);</div>
<div class="line">    solver.set_optim_constraint_tolerance(1e-4);</div>
<div class="line"> </div>
<div class="line">    MocoSolution solution = study.solve();</div>
<div class="line">    <a name="a1"></a><a class="code" href="classOpenSim_1_1STOFileAdapter__.html#af40f174e371ab93d659a8223ed90458d">STOFileAdapter::write</a>(solution.exportToStatesTable(),</div>
<div class="line">            <span class="stringliteral">&quot;exampleHangingMuscle_states.sto&quot;</span>);</div>
<div class="line">    <a class="code" href="classOpenSim_1_1STOFileAdapter__.html#af40f174e371ab93d659a8223ed90458d">STOFileAdapter::write</a>(solution.exportToControlsTable(),</div>
<div class="line">            <span class="stringliteral">&quot;exampleHangingMuscle_controls.sto&quot;</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Conduct an analysis using MuscleAnalysis and ProbeReporter.</span></div>
<div class="line">    {</div>
<div class="line">        <span class="comment">// Create an AnalyzeTool setup file.</span></div>
<div class="line">        AnalyzeTool <a name="a2"></a><a class="code" href="group__simulationutil.html#gabadb22afcecdebfaa78d9a95bd35d336">analyze</a>;</div>
<div class="line">        <a class="code" href="group__simulationutil.html#gabadb22afcecdebfaa78d9a95bd35d336">analyze</a>.setName(<span class="stringliteral">&quot;analyze&quot;</span>);</div>
<div class="line">        <a class="code" href="group__simulationutil.html#gabadb22afcecdebfaa78d9a95bd35d336">analyze</a>.setModelFilename(<span class="stringliteral">&quot;hanging_muscle.osim&quot;</span>);</div>
<div class="line">        <a class="code" href="group__simulationutil.html#gabadb22afcecdebfaa78d9a95bd35d336">analyze</a>.setStatesFileName(<span class="stringliteral">&quot;exampleHangingMuscle_states.sto&quot;</span>);</div>
<div class="line">        <a class="code" href="group__simulationutil.html#gabadb22afcecdebfaa78d9a95bd35d336">analyze</a>.updAnalysisSet().adoptAndAppend(<span class="keyword">new</span> MuscleAnalysis());</div>
<div class="line">        <a class="code" href="group__simulationutil.html#gabadb22afcecdebfaa78d9a95bd35d336">analyze</a>.updAnalysisSet().adoptAndAppend(<span class="keyword">new</span> ProbeReporter());</div>
<div class="line">        <a class="code" href="group__simulationutil.html#gabadb22afcecdebfaa78d9a95bd35d336">analyze</a>.updControllerSet().adoptAndAppend(</div>
<div class="line">                <span class="keyword">new</span> PrescribedController(<span class="stringliteral">&quot;exampleHangingMuscle_controls.sto&quot;</span>));</div>
<div class="line">        <a class="code" href="group__simulationutil.html#gabadb22afcecdebfaa78d9a95bd35d336">analyze</a>.print(<span class="stringliteral">&quot;exampleHangingMuscle_AnalyzeTool_setup.xml&quot;</span>);</div>
<div class="line">    }</div>
<div class="line">    <span class="comment">// Run the analysis.</span></div>
<div class="line">    AnalyzeTool <a class="code" href="group__simulationutil.html#gabadb22afcecdebfaa78d9a95bd35d336">analyze</a>(<span class="stringliteral">&quot;exampleHangingMuscle_AnalyzeTool_setup.xml&quot;</span>);</div>
<div class="line">    <a class="code" href="group__simulationutil.html#gabadb22afcecdebfaa78d9a95bd35d336">analyze</a>.run();</div>
<div class="line"> </div>
<div class="line">    <span class="keywordflow">return</span> EXIT_SUCCESS;</div>
<div class="line">}</div>
<div class="ttc" id="aclassOpenSim_1_1STOFileAdapter___html_af40f174e371ab93d659a8223ed90458d"><div class="ttname"><a href="classOpenSim_1_1STOFileAdapter__.html#af40f174e371ab93d659a8223ed90458d">OpenSim::STOFileAdapter_::write</a></div><div class="ttdeci">static void write(const TimeSeriesTable_&lt; T &gt; &amp;table, const std::string &amp;fileName)</div><div class="ttdoc">Write a STO file.</div><div class="ttdef"><b>Definition:</b> STOFileAdapter.h:139</div></div>
<div class="ttc" id="aclassOpenSim_1_1SliderJoint_html_a1c93d708a12564b46fcde77bb4be66eaadf25457a4acbb8220b36cbd34903fc06"><div class="ttname"><a href="classOpenSim_1_1SliderJoint.html#a1c93d708a12564b46fcde77bb4be66eaadf25457a4acbb8220b36cbd34903fc06">OpenSim::SliderJoint::Coord::TranslationX</a></div><div class="ttdeci">@ TranslationX</div><div class="ttdoc">0</div></div>
<div class="ttc" id="agroup__simulationutil_html_gabadb22afcecdebfaa78d9a95bd35d336"><div class="ttname"><a href="group__simulationutil.html#gabadb22afcecdebfaa78d9a95bd35d336">OpenSim::analyze</a></div><div class="ttdeci">TimeSeriesTable_&lt; T &gt; analyze(Model model, const TimeSeriesTable &amp;statesTable, const TimeSeriesTable &amp;controlsTable, const std::vector&lt; std::string &gt; &amp;outputPaths, const TimeSeriesTable &amp;discreteVariablesTable={})</div><div class="ttdoc">Calculate the requested outputs using the model in the problem and the provided states and controls t...</div><div class="ttdef"><b>Definition:</b> SimulationUtilities.h:222</div></div>
<div class="ttc" id="anamespaceOpenSim_html"><div class="ttname"><a href="namespaceOpenSim.html">OpenSim</a></div><div class="ttdoc">The Moco interface is contained within the OpenSim namespace.</div><div class="ttdef"><b>Definition:</b> ActivationCoordinateActuator.h:30</div></div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:39 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
